require "numru/dclext_streamline.so"

module NumRu
  module DCLExt

    module_function

    def streamline(u,v,xx,yy,dl,idensity,type,index)
      if (u.shape != v.shape || u.shape != xx.shape || u.shape != yy.shape)
        raise("Shapes of u, v, xx, yy should be the same!!")
      end
      if defined?(NArrayMiss)
        if u.is_a?(NArrayMiss)
          mask = u.get_mask
          u = u.to_na(0)
        end
        if v.is_a?(NArrayMiss)
          if mask
            mask *= v.get_mask
          else
            mask = v.get_mask
          end
          v = v.to_na(0) 
        end
      end
      # mask for missing value is not yet implemented
      streamline_c(u,v,xx,yy,dl,idensity,type,index)
    end
  end
end
