#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "libtinyf2c.h"

#ifndef STREAM_C_H
#define STREAM_C_H

struct StreamOpt{
  float dt_thresh0;
  float dt_thresh1;
  float loop_thresh;
  float touch_thresh;
  float slow_thresh;
  float tarrow;
  float arrowsize;
  float arrowsize_map;
  int lines_max;
  integer type;
  integer index;
};

extern char streamline_debug;

void streamline(int nx,int ny,float *u,float *v,float *xx,float *yy,float dl,int idensity,struct StreamOpt opt);

void streamline_core(int nx,int ny,float *u,float *v,float *xx,float *yy,float dl,float sx,float sy,float *lines_x,float *lines_y,int *lines_id,int *lines_pos,int id,struct StreamOpt opt);

int rungekutta_2d(int nx,int ny,float *u,float *v,float x0,float y0,float dt,float *dx,float *dy);

int interp_2d_vect(int nx,int ny,float *u,float *v,float x,float y,float *u0,float *v0);

#endif //ifndef STREAM_C_H
